<?php

/*** Function bỏ dấu tiếng việt ***/
function seo($link){
$a_str = array("ă", "ắ", "ằ", "ẳ", "ẵ", "ặ", "á", "à", "ả", "ã", "ạ", "â", "ấ", "ầ", "ẩ", "ẫ", "ậ", "Á", "À", "Ả", "Ã", "Ạ", "Ă", "Ắ", "Ằ", "Ẳ", "Ẵ", "Ặ", "Â", "Ấ", "Ầ", "Ẩ", "Ẫ", "Ậ", "ä", "æ", "Ä", "Æ");
$e_str = array("é","è","ẻ","ẽ","ẹ","ê","ế","ề","ể","ễ","ệ","ë","É","È","Ẻ","Ẽ","Ẹ","Ê","Ế","Ề","Ể","Ễ","Ệ","Ë","ð");
$d_str = array("đ","Đ");
$o_str = array("ó","ò","ỏ","õ","ọ","ô","ố","ồ","ổ","ỗ","ộ","ơ","ớ","ờ","ở","ỡ","ợ","ö","ø","Ó","Ò","Ỏ","Õ","Ọ","Ô","Ố","Ồ","Ổ","Ỗ","Ộ","Ơ","Ớ","Ờ","Ở","Ỡ","Ợ","Ö","Ø");
$u_str = array("ú","ù","ủ","ũ","ụ","ư","ứ","ừ","ữ","ử","ự","ü","û","Ú","Ù","Ủ","Ũ","Ụ","Ư","Ứ","Ừ","Ử","Ữ","Ự","Ü","Û");
$i_str = array("í","ì","ỉ","ị","ĩ","ï","î","Í","Ì","Ỉ","Ị","Ĩ","Î","Ï");
$y_str = array("ý","ỳ","ỷ","ỵ","ỹ","Ý","Ỳ","Ỷ","Ỵ","Ỹ");
$da_str = array("́","̀","̉","̃","̣");
$kt=array('.', ',', '%', '+', '`', '[', ']', '/', '-', '(', ')', '§', '~', '€', '@', ';', ':', '{', '}', '¿', '"', '?', '£', '¤', '<', '>', '¥', '*', '|', '!', '¡', '#', '₫', '$', '&', '^');
$link= str_replace($i_str,"i",$link);
$link = str_replace($da_str,"",$link);
$link = str_replace($y_str,"y",$link);
$link = str_replace($a_str,"a",$link);
$link = str_replace($e_str,"e",$link);
$link = str_replace($d_str,"d",$link);
$link = str_replace($u_str,"u",$link);
$link = str_replace($o_str,"o",$link);
$link = str_replace($kt," ",$link);
$link=strtolower($link);
$link=preg_replace('#[^a-z0-9]#', ' ', $link);
$link=preg_replace('/\s\s+/',' ',$link);
$link=trim($link);
$link=str_replace(" ", "-", $link);
return $link;
}
/*** Function fix lại font chữ chuẩn utf-8 - code: quoctrung***/
function fixfont($text){
$text = str_ireplace('http: ', 'http:', $text);
$nd = array("á" => "á", "à" => "à", "ả" => "ả", "ã" => "ã", "ạ" => "ạ", "Á" => "Á", "À" => "À", "Ả" => "Ả", "Ã" => "Ã", "Ạ" => "Ạ", "ắ" => "ắ", "ằ" => "ằ", "ẳ" => "ẳ", "ẵ" => "ẵ", "ặ" => "ặ", "Ắ" => "Ắ", "Ằ" => "Ằ", "Ẳ" => "Ẳ", "Ẵ" => "Ẵ", "Ặ" => "Ặ", "ấ" => "ấ", "ẩ" => "ẩ", "ầ" => "ầ", "ẫ" => "ẫ", "ậ" => "ậ", "Ấ" => "Ấ", "Ầ" => "Ầ", "Ẩ" => "Ẩ", "Ẫ" => "Ẫ", "Ậ" => "Ậ", "é" => "é", "è" => "è", "ẻ" => "ẻ", "ẽ" => "ẽ", "ẹ" => "ẹ", "É" => "É", "È" => "È", "Ẻ" => "Ẻ", "Ẽ" => "Ẽ", "Ẹ" => "Ẹ", "ế" => "ế", "ề" => "ề", "ể" => "ể", "ễ" => "ễ", "ệ" => "ệ", "Ế" => "Ế", "Ề" => "Ề", "Ể" => "Ể", "Ễ" => "Ễ", "Ệ" => "Ệ", "í" => "í", "ì" => "ì", "ỉ" => "ỉ", "ĩ" => "ĩ", "ị" => "ị", "Í" => "Í", "Ì" => "Ì", "Ỉ" => "Ỉ", "Ĩ" => "Ĩ", "Ị" => "Ị", "ó" => "ó", "ò" => "ò", "ỏ" =>
"ỏ", "õ" => "õ", "ọ" => "ọ", "Ó" => "Ó", "Ò" => "Ò", "Ỏ" => "Ỏ", "Õ" => "Õ", "Ọ" => "Ọ", "ố" => "ố", "ồ" => "ồ", "ổ" => "ổ", "ỗ" => "ỗ", "ộ" => "ồ", "Ố" => "Ố", "Ồ" => "Ồ", "Ổ" => "Ổ", "Ỗ" => "Ỗ", "Ộ" => "Ộ", "ợ" => "ợ", "ờ" => "ờ", "ớ" => "ớ", "ở" => "ở", "ỡ" => "ỡ", "Ớ" => "Ớ", "Ờ" => "Ờ", "Ở" => "Ở", "Ỡ" => "Ỡ", "Ợ" => "Ợ", "ú" => "ú", "ù" => "ù", "ủ" => "ủ", "ũ" => "ũ", "ụ" => "ụ", "Ú" => "Ú", "Ù" => "Ù", "Ủ" => "Ủ", "Ũ" => "Ũ", "Ụ" => "Ụ", "ứ" => "ứ", "ừ" => "ừ", "ử" => "ử", "ữ" => "ữ", "ự" => "ự", "Ứ" => "Ứ", "Ừ" => "Ừ", "Ử" => "Ử", "Ữ" => "Ữ", "Ự" => "Ự", "ý" => "ý", "ỳ" => "ỳ", "ý" => "ỷ", "ỹ" => "ỹ", "ỵ" => "ỵ", "Ý" => "Ý", "Ỳ" => "Ỳ", "Ỷ" => "Ỷ", "Ỹ" => "Ỹ", "Ỵ" => "Ỵ");
$text = str_replace(array_keys($nd), array_values($nd), $text);
$text = html_entity_decode($text, ENT_QUOTES, 'UTF-8');
$ndx = array(
'&acirc;' => 'a','&aacute;' => 'á','&agrave;' => 'à','&acirc;̉' => 'ả','&atilde;' => 'ã','&acirc;̣' => 'ạ',
'&Acirc;' => 'A','&Aacute;' => 'Á','&Agrave;' => 'À','&Acirc;̉' => 'Ả','&Atilde;' => 'Ã','&Acirc;̣' => 'Ạ',
'&acirc;' => 'ă','&acirc;́' => 'ắ','&acirc;̀' => 'ằ','&acirc;̉' => 'ẳ','&acirc;̃' => 'ẵ','&acirc;̣' => 'ặ',
'&Acirc;' => 'Ă','&Acirc;́' => 'Ắ','&Acirc;̀' => 'Ằ','&Acirc;̉' => 'Ẳ','&Acirc;̃' => 'Ẵ','&Acirc;̣' => 'Ặ',
'&acirc;' => 'â','&acirc;́' => 'ấ','&acirc;̀' => 'ầ','&acirc;̉' => 'ẩ','&acirc;̃' => 'ẫ','&acirc;̣' => 'ậ',
'&Acirc;' => 'Â','&Acirc;́' => 'Ấ','&Acirc;̀' => 'Ầ','&Acirc;̉' => 'Ẩ','&Acirc;̃' => 'Ẫ','&Acirc;̣' => 'Ậ',
'&ecirc;' => 'e','&eacute;' => 'é','&eagrave;' => 'è','&ecirc;̉' => 'ẻ','&etilde;' => 'ẽ','&ecirc;̣' => 'ẹ',
'&Ecirc;' => 'E','&Eacute;' => 'É','&Egrave;' => 'È','&Ecirc;̉' => 'Ẻ','&Etilde;' => 'Ẽ','&Ecirc;̣' => 'Ẹ',
'&ecirc;' => 'ê','&ecirc;́' => 'ế','&ecirc;̀' => 'ề','&ecirc;̉' => 'ể','&ecirc;̃' => 'ễ','&ecirc;̣' => 'ệ',
'&Ecirc;' => 'Ê','&Ecirc;́' => 'Ế','&Ecirc;̀' => 'Ề','&Ecirc;̉' => 'Ể','&Ecirc;̃' => 'Ễ','&Ecirc;̣' => 'Ệ',
'&icirc;' => 'i','&iacute;' => 'í','&igrave;' => 'ì','&icirc;̉' => 'ỉ','&itilde;' => 'ĩ','&icirc;̣' => 'ị',
'&Icirc;' => 'I','&Iacute;' => 'Í','&Igrave;' => 'Ì','&Icirc;̉' => 'Ỉ','&Itilde;' => 'Ĩ','&Icirc;̣' => 'Ị',
'&ucirc;' => 'u', '&uacute;' => 'ú','&ugrave;' => 'ù','&ucirc;̉' => 'ủ','&utilde;' => 'ũ','&ucirc;̣' => 'ụ',
'&Ucirc;' => 'U','&Uacute;' => 'Ú','&Ugrave;' => 'Ù','&Ucirc;̉' => 'Ủ','&Utilde;' => 'Ũ','&Ucirc;̣' => 'Ụ',
'&ucirc;' => 'ư','&ucirc;́' => 'ứ','&ucirc;̀' => 'ừ','&ucirc;̉' => 'ử','&ucirc;̃' => 'ữ','&ucirc;̣' => 'ự',
'&Ucirc;' => 'Ư','&Ucirc;́' => 'Ứ','&Ucirc;̀' => 'Ừ','&Ucirc;̉' => 'Ử','&Ucirc;̃' => 'Ữ','&Ucirc;̣' => 'Ự',
'&ocirc;' => 'o', '&oacute;' => 'ó','&ograve;' => 'ò','&ocirc;̉' => 'ỏ','&otilde;' => 'õ','&ocirc;̣' => 'ọ',
'&Ocirc;' => 'O','&Oacute;' => 'Ó','&Ograve;' => 'Ó','&Ocirc;̉' => 'Ỏ','&Otilde;' => 'Õ','&Ocirc;̣' => 'Ọ',
'&ocirc;' => 'ơ','&ocirc;́' => 'ớ','&ocirc;̀' => 'ờ','&ocirc;̉' => 'ở','&ocirc;̃' => 'ỡ','&ocirc;̣' => 'ợ',
'&Ocirc;' => 'Ơ','&Ocirc;́' => 'Ớ','&Ocirc;̀' => 'Ờ','&Ocirc;̉' => 'Ở','&Ocirc;̃' => 'Ỡ','&Ocirc;̣' => 'Ợ',
'&ocirc;' => 'ô', '&ocirc;́' => 'ố','&ocirc;̀' => 'ồ','&ocirc;̉' => 'ổ','&ocirc;̃' => 'ỗ','&ocirc;̣' => 'ộ',
'&Ocirc;' => 'Ô','&Ocirc;́' => 'Ố','&Ocirc;̀' => 'Ồ','&Ocirc;̉' => 'Ổ','&Ocirc;̃' => 'Ỗ','&Ocirc;̣' => 'Ộ',
'&ycirc;' => 'y','&yacute;' => 'ý','&ygrave;' => 'ỳ','&ycirc;̉' => 'ỷ','&ytilde;' => 'Ỹ','&ycirc;̣' => 'ỵ',
'&Ycirc;' => 'Y','&Yacute;' => 'Ý','&Ygrave;' => 'Ỳ','&Ycirc;̉' => 'Ỷ','&Ytilde;' => 'Ỹ','&Ycirc;̣' => 'Ỵ'
);
$text = str_replace(array_keys($ndx), array_values($ndx), $text);
$text = trim($text);
return $text;
}
/*** Function loại bỏ các thẻ bbcode - code: quoctrung ***/
function delbb($text){
$nd = array("/\[b\](.*?)\[\/b\]/is" => "$1",
"/\[em\](.*?)\[\/em\]/is" => "$1",
"/\[strong\](.*?)\[\/strong\]/is" => "$1",
"/\[p\](.*?)\[\/p\]/is" => "$1",
"/\[i\](.*?)\[\/i\]/is" => "$1",
"/\[u\](.*?)\[\/u\]/is" => "$1",
"/\[s\](.*?)\[\/s\]/is" => "$1",
"/\[center\](.*?)\[\/center\]/is" => "$1", "/\[download\](.*?)\[\/download\]/is" => "$1", "/\[right\](.*?)\[\/right\]/is" => "$1",
"/\[left\](.*?)\[\/left\]/is" => "$1", "/\[red\](.*?)\[\/red\]/is" => "$1",
"/\[blue\](.*?)\[\/blue\]/is" => "$1",
"/\[yellow\](.*?)\[\/yellow\]/is" => "$1",
"/\[green\](.*?)\[\/green\]/is" => "$1",
"/\[img\](.*?)\[\/img\]/is" => "",
"/\[url\=(.*?)\](.*?)\[\/url\]/is" => "$1", "/\[url\](.*?)\[\/url\]/is" => "$1",
"/\[color\=(.*?)\](.*?)\[\/color\]/is" => "$2",
"/\[size\=(.*?)\](.*?)\[\/size\]/is" => "$2", "/\[quote\=(.*?)\](.*?)\[\/quote\]/is" => "Nguyên văn bởi $1: \"$2\"", "/\[quote\](.*?)\[\/quote\]/is" => "Trích: \"$1\"",
"/\[text\](.*?)\[\/text\]/is" => "$1", "/\[hide\](.*?)\[\/hide\]/is" => "$1", "/\[youtube\](.*?)\[\/youtube\]/is" => "$1", "/\n\n+/" => " ");
$text = preg_replace(array_keys($nd), array_values($nd), $text);
$text = str_replace("\r\n", " ", $text);
$text = trim($text);
return $text;
}

/*** Function xử lý url để lấy path ***/
function xlurl($url){
$url=parse_url(strip_tags($url), PHP_URL_PATH);
$url=str_replace('index', '', $url);
$url=str_replace('.html', '', $url);
$url=str_replace('.txt', '', $url);
$url=preg_replace('#(.*?)([.])(.*?)([.])(.*?)([.])(.*?)/|(.*?)([.])(.*?)([.])(.*?)/|(.*?)([.])(.*?)/#i', '', $url);
$url=ltrim($url, '/');
return $url;
}
/*** Function đóng dấu hình ảnh bằng chữ giống Haivl.com - bởi: mrtaiw - mod bởi: quoctrung***/
function dongdau($image, $text, $save){
$font = 'font.ttf';
$compress = '95'; //chất lượng nén ảnh, tính bằng %
$gocquay= '0';//goc quay
$size = '18'; // Cỡ chữ
$tcolor = '808080';//màu chữ dạng hex

$a = imagettfbbox($size, $gocquay, $font, $text);
$width = abs($a[0]) + abs($a[2]);//chiều rộng text
$height = abs($a[5])+abs($a[1]);//chiều cao text

$info = getimagesize($image);
$mime = $info['mime'];
$h = $info[1];
$w = $info[0];
if($w>=$width+4){

if($mime=='image/png'){
$im = imagecreatefrompng($image);
}
elseif($mime=='image/jpeg'){
$im = imagecreatefromjpeg($image);
}
elseif($mime=='image/gif'){
$im = imagecreatefromgif($image);
}
$new_h = $h+$height;//chiều cao của hình ảnh mới

$new_im= imagecreatetruecolor($w, $new_h); //tạo ảnh mới
$white = imagecolorallocate($new_im, 255, 255, 255);
imagefill($new_im, 0, 0, $white); //tô màu trắng
imagecolortransparent($new_im, $white);

$redtext = hexdec(substr($tcolor, 1, 2));
$greentext = hexdec(substr($tcolor, 3, 2));
$bluetext = hexdec(substr($tcolor, 5, 2));
$text_color = imagecolorallocate($new_im, $redtext, $greentext, $bluetext);//màu text

imagettftext($new_im, $size, $gocquay, $w-$width-5, $h+abs($a[5]), $text_color, $font, $text);//in text lên ảnh mới

imagealphablending($new_im,false);
imagesavealpha($new_im,true);

imagecopy ($new_im, $im, 0, 0, 0, 0, $w, $h); //copy ảnh cần đóng dấu vào ảnh mới

if($mime=='image/png'){
imagepng($new_im, $save);
}
elseif($mime=='image/jpeg'){
imagejpeg($new_im, $save, $compress);
}
elseif($mime=='image/gif'){
imagegif($new_im, $save);
return true;
}

}else{
if (copy($image,$save)) return true;
}

}//endfunc

?>
